//---------------------------------------------------------------------------

#pragma hdrstop

#include "UCTable.h"

//---------------------------------------------------------------------------

void Key(void)
{
  cout<<endl<<"Nacisnij klawisz"<<endl;
  getch();
}
//---------------------------------------------------------------------------
SObiekt::SObiekt(void)
{
   liczbaAtrybutow=0;
   atrybutyPtr=NULL;
   klasaRozpoznana=-1;
   klasaRzeczywista=-1;
   silaGlosu=0;
   ufnosc=0;
}
//---------------------------------------------------------------------------
SObiekt::SObiekt(int size)
{
   try
   {
	this->atrybutyPtr =NULL;
	Alloc(size);
	klasaRozpoznana=-1;
	klasaRzeczywista=-1;
	silaGlosu=0;
	ufnosc=0;
   }
   catch(...)
   {
	 cout<<BAD_ALLOC.c_str();
	 Key(); exit(1);
   }

}
//---------------------------------------------------------------------------
SObiekt::SObiekt (const SObiekt &source)
{
Kopiuj(source);
}
//---------------------------------------------------------------------------
void SObiekt::Pisz(int tryb)
{

 cout<<endl<<"[";
 for(int i=0;i<this->liczbaAtrybutow;i++)
  cout<<this->atrybutyPtr[i]<<" ";
 cout<<"]";


 if((tryb & KLASAROZ)==KLASAROZ)
  cout<<" ->KL. ROZ="<<this->klasaRozpoznana;
 if((tryb & KLASARZE)==KLASARZE)
  cout<<" KL. RZ="<<this->klasaRzeczywista;
 if((tryb & SILAGLOSU)==SILAGLOSU)
  cout<<" SG="<<this->silaGlosu;
 if((tryb & UFNOSC)==UFNOSC)
  cout<<" UFN="<<this->ufnosc;
 if((tryb & LICZBAARG)==LICZBAARG)
  cout<<" LA="<<this->liczbaAtrybutow;
}

//---------------------------------------------------------------------------
SObiekt::~SObiekt(void)
{
 delete [] atrybutyPtr;
}
//---------------------------------------------------------------------------
void SObiekt::Alloc(int size)
{
  delete [] this->atrybutyPtr;
  try
   {
	this->atrybutyPtr =new double[size];
   }
   catch(...)
   {
	 cout<<BAD_ALLOC.c_str();
	 Key(); exit(1);
   }
   this->liczbaAtrybutow=size;
}
//---------------------------------------------------------------------------

void SObiekt::Kopiuj(const SObiekt & source)
{
 Alloc(source.liczbaAtrybutow);
 memcpy((char*)atrybutyPtr,(char*)source.atrybutyPtr,sizeof(double)*
 liczbaAtrybutow);
 this->klasaRozpoznana=source.klasaRozpoznana;
 this->klasaRzeczywista=source.klasaRzeczywista;
 this->silaGlosu=source.silaGlosu;
 this->ufnosc=source.ufnosc;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
CTablicaObiektow::CTablicaObiektow(void)
{
  liczbaObiektow=0;
  obiektyPtr=NULL;
  maxLiczbaObiektow=0;
  wagiPtr=NULL;
  wParam=false;
}
CTablicaObiektow::~CTablicaObiektow(void)
{
 Czysc();
}
//---------------------------------------------------------------------------
SObiekt &CTablicaObiektow::operator[](int i)
{
 return obiektyPtr[i];
}
//---------------------------------------------------------------------------
void CTablicaObiektow::Dodaj(SObiekt &in)
{
  if(liczbaObiektow==maxLiczbaObiektow)
  {
   int tmp=maxLiczbaObiektow+MAXCAP;
   try
   {
	SObiekt *tmpPtr=new SObiekt[tmp];
	Kopiuj(tmpPtr,obiektyPtr,liczbaObiektow);
	delete [] obiektyPtr;
	obiektyPtr=tmpPtr;
   }
   catch(...)
   {
	 cout<<BAD_ALLOC.c_str();
	 Key(); exit(1);
   }
   maxLiczbaObiektow=tmp;
  }
  obiektyPtr[liczbaObiektow].Kopiuj(in);
  liczbaObiektow++;
}
 //---------------------------------------------------------------------------
 void CTablicaObiektow::Kopiuj(SObiekt *dest,SObiekt * source,int elem)
 {
  for(int i=0;i<elem;i++)
	dest[i].Kopiuj(source[i]);
 }
 //---------------------------------------------------------------------------
 void CTablicaObiektow::Czysc(void)
 {
   delete [] obiektyPtr;
   obiektyPtr=NULL;
   maxLiczbaObiektow=0;
   liczbaObiektow=0;
   if(wagiPtr!=0) delete[] wagiPtr;
 }
//---------------------------------------------------------------------------
 void CTablicaObiektow::Usun(void)
 {
   liczbaObiektow--;
 }
 //---------------------------------------------------------------------------
 int CTablicaObiektow::DajLiczbeObiektow(void)
 {
   return this->liczbaObiektow;
 }
 //---------------------------------------------------------------------------

 int CTablicaObiektow::DajLiczbaAtrybutow(void)
 {
	if(obiektyPtr!=NULL)
	 return this->obiektyPtr[0].liczbaAtrybutow;
	return 0;
 }

 //---------------------------------------------------------------------------
void CTablicaObiektow::Pisz(int tryb)
 {
  if(this->liczbaObiektow==0)
   cout<<endl<<"Brak dancyh!";
  else
   for(int i=0;i<liczbaObiektow;i++)
	 this->obiektyPtr[i].Pisz(tryb);
 }
//---------------------------------------------------------------------------
bool CTablicaObiektow::WczytajZPliku(char *nazwa,int tryb)
{
  ifstream inFile(nazwa);
  if(!inFile.is_open()) return false;
  inFile.clear();
  int lArg=0;

  //TRYB_DANETRENUJACE
  //pierwsza linia to liczba argumentow n
  //nastepnie dane - n wartosci i informacja o klasie
  //wagi podawane s z klawiatury
  //etykiety klas mog by tylko 0 lub 1

   if(tryb== TRYB_DANETRENUJACE)
   {
	 inFile>>lArg;
	 SObiekt tmp(lArg);

	 while(!inFile.eof())
	 {
	  for(int i=0;i<lArg;i++)
		inFile>>tmp.atrybutyPtr[i];
	  if(!inFile.eof())
	  {
	   inFile>>tmp.klasaRzeczywista;
	   Dodaj(tmp);
	  }
	 }
   }
   else
   if(tryb==TRYB_DANEDOROZPOZNANIA )
   {
  //TRYB_DANEDOROZPOZNANIA
  //pierwsza linia to liczba argumentow
  //nastepnie dane - n wartosci
	 inFile>>lArg;
	 SObiekt tmp(lArg);

	 while(!inFile.eof())
	 {
	  for(int i=0;i<lArg;i++)
		inFile>>tmp.atrybutyPtr[i];
	  if(!inFile.eof())
		Dodaj(tmp);
	 }
	}


   inFile.clear();
   inFile.close();
   return true;
}
//---------------------------------------------------------------------------
bool CTablicaObiektow::ZapiszDoPliku(char *nazwa)
{
ofstream plik;
plik.open(nazwa);

if(plik.is_open())
{
for(int i=0;i<liczbaObiektow;i++)
 {
  plik<<endl<<"[";
 for(int j=0;j<obiektyPtr[0].liczbaAtrybutow;j++)
  plik<<this->obiektyPtr[i].atrybutyPtr[j]<<" ";
  plik<<"]";
  plik<<" ->KL. ROZ="<<this->obiektyPtr[i].klasaRozpoznana;
  plik<<" SG="<<this->obiektyPtr[i].silaGlosu;
  plik<<" UFN="<<this->obiektyPtr[i].ufnosc;
 }
 plik.close();
}
else
 return false;
return true;
}
//---------------------------------------------------------------------------
 void CTablicaObiektow::UstawWagi(double * tablica)
 {
	 delete []wagiPtr;
	 try
	 {
	 wagiPtr=new double[this->DajLiczbaAtrybutow()];
	 memcpy((char*)this->wagiPtr,(char*)tablica,
	 this->DajLiczbaAtrybutow()*sizeof(double));
	 }
	 catch(...)
	 {
	  cout<<BAD_ALLOC.c_str();
	  Key(); exit(1);
     }
 }
 //---------------------------------------------------------------------------
 void CTablicaObiektow::UstawParametry(bool w,int k,int m)
 {
   this->wParam=w;
   this->kParam=k;
   this->mParam=m;
 }
 //---------------------------------------------------------------------------
 int CTablicaObiektow::DajK(void)
 {
   return kParam;
 }
 //---------------------------------------------------------------------------
 int CTablicaObiektow::DajM(void)
 {
	 return mParam;
 }
 //---------------------------------------------------------------------------
 bool   CTablicaObiektow::DajW(void)
 {
   return wParam;
 }
 //---------------------------------------------------------------------------
 void CTablicaObiektow::DajWagi(double ** wagi)
 {
  int n=0;
  if(this->wParam==false)
   {
	(*wagi)=NULL;
    return;
   }
  n=this->DajLiczbaAtrybutow();
  *wagi=new double[n];
  for(int i=0;i<n;i++)
	(*wagi)[i]=this->wagiPtr[i];

 }
 //---------------------------------------------------------------------------
 void CTablicaObiektow::KopiujZWylaczeniem(CTablicaObiektow &o,int n)
 {
  this->Czysc();
  for(int i=0;i<o.DajLiczbeObiektow();i++)
   {
	if(i!=n)
	 this->Dodaj(o[i]);
	else
	{
   this->wParam=o.wParam;
   this->kParam=o.kParam;
   this->mParam=o.mParam;
   if(wParam==true)
   {
     this->wagiPtr= new double[o.DajLiczbaAtrybutow()];
	 memcpy((char*)this->wagiPtr,(char*)o.wagiPtr,sizeof(double)*o.DajLiczbaAtrybutow());
	}
	}
   }
 }
 //--------------------------------------------------------------------------
#pragma package(smart_init)
