//---------------------------------------------------------------------------

#ifndef UCTableH
#define UCTableH

#include <limits.h>
#include <string>
#include <iostream>
#include <fstream>
#include <conio.h>

//---------------------------------------------------------------------------

using namespace std;
const int MAXCAP=10;
const int MAXARG=50; //max argumentow
const string BAD_ALLOC="\nBlad alokacji pamieci";
const int KLASAROZ=1; //klasa rozpoznana
const int KLASARZE=2; //klasa rzeczywisa
const int SILAGLOSU=4;
const int UFNOSC=8;
const int LICZBAARG=16;
const int TRYB_DANETRENUJACE=1;
const int TRYB_DANEDOROZPOZNANIA=2;

void Key(void);


struct SErrors
{
  int TN,TP,FN,FP;
  double overErr;
  double skutecznosc;
  double czulosc;
  double specyficznosc;
  double falsePositiveRate;
  double positivePreictiveValue;
  double negativePredictiveValue;
  double falseDiscoveryRate;
  double MatthewCorrCoeff;
  double F1Score;
  double MSE;
  //macierz pomylek
  void Pisz(void);
};

struct SObiekt
{
  SObiekt(void);
  SObiekt(int size);
  SObiekt (const SObiekt &);
  ~SObiekt(void);
  void Pisz(int tryb);

   void Kopiuj(const SObiekt &);
   int liczbaAtrybutow;
   double *atrybutyPtr;

   int klasaRozpoznana;
   int klasaRzeczywista;
   double silaGlosu;
   double ufnosc;
  private:
   void Alloc(int size);

};



class CTablicaObiektow
{

 public:
  CTablicaObiektow(void);
  ~CTablicaObiektow(void);
  SObiekt &operator[](int);
  bool WczytajZPliku(char *nazwa,int tryb);
  bool ZapiszDoPliku(char *nazwa);
  bool ZapiszDoPliku(char *nazwa,SErrors &s);
  void Dodaj(SObiekt &); //dodaje ns kocu
  void Usun(void); //usuwa ostatni
  void Czysc(void); //usuwa wszytskie
  int DajLiczbeObiektow(void);
  int DajLiczbaAtrybutow(void);
  void Pisz(int tryb=0);
  void Kopiuj(SObiekt *,SObiekt *,int);
  void UstawWagi(double *);
  void UstawParametry(bool,int,int);
  void KopiujZWylaczeniem(CTablicaObiektow &,int);
  int DajK(void);
  int DajM(void);
  bool DajW(void);
  void DajWagi(double **);

 private:
  int liczbaObiektow;
  SObiekt *obiektyPtr;
  int maxLiczbaObiektow;

  double *wagiPtr;

  bool wParam;
  int kParam;
  int mParam;


};




#endif
