
#include "UCTable.h"
#include "UMethods.h"


//program do klasyfikacji binarnej metod najblizszych ssiadw
//(C) Maciej Tabaszewski ver. 2.0 2018


using namespace std;

const int STRING_LEN=256;
bool dane1Gotowe=false;
bool dane2Gotowe=false;
bool wyniki1Gotowe=false;
bool wyniki2Gotowe=false;
//parametry domyslne
int mParam=2,kParam=3;
bool wParam=false;

CTablicaObiektow daneTrenujace;
CTablicaObiektow daneDoRozpoznania;
SErrors testErrors;

//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
char Menu(void)
{
  cout<<endl;
  cout<<     "***************** MENU **************************";
  cout<<endl<<"0-podaj parametry klasyfikacji (";
  wParam==0? cout<<"bez wag,": cout<<"z wagami,"; //podaj wagi jesli s wymagane
  cout<<" m="<<mParam; cout<<", k="<<kParam<<")";
  cout<<endl<<"1-wczytaj dane trenujace";
  cout<<endl<<"2-wykonaj test klasyfikatora";
  cout<<endl<<"3-wczytaj plik z danymi do klasyfikacji";
  cout<<endl<<"4-klasyfikacja";
  cout<<endl<<"5-prezentuj wczytane dane trenujace";
  cout<<endl<<"6-prezentuj wczytane dane do rozpoznania";
  cout<<endl<<"7-prezentuj wyniki klasyfikacji";

  cout<<endl<<"9-zapisz wyniki klasyfikacji do pliku";
  cout<<endl<<"s-stop";
  cout<<endl<<"************************************************";
  cout<<endl;
  return getch();
}
//------------------------------------------------------------------------------

int main(void)
{
bool stop=false;
char nazwa[STRING_LEN];
double wagi[MAXARG];

  do
	{
	  switch(Menu())
	  {
	   case 's':
		stop=true;
	   break;
	   //*********************
	   case '0':
		 if(!dane1Gotowe) { cout<<endl<<"Najpierw wczytaj dane trenujace!"; break;}

		 cout<<endl<<"Czy uwzglednic wagi? (t/n)";
		 char decyzja; cin>>decyzja;
		 switch(decyzja)
		 {
		  case 't':
		  case 'T':
		   cout<<endl<<"Podawaj kojne wagi "<<endl;
		   for(int i=0;i<daneTrenujace.DajLiczbaAtrybutow();i++)
			{
			  cout<<"Atrybut "<<i+1<<" w="; cin>>wagi[i];
			}
		   wParam=true;
		   daneTrenujace.UstawWagi(wagi);

		  break;

		  case 'n':
		  case 'N':
			 wParam=false;

		  break;
		  default:
		   cout<<endl<<"Wybierz t lub n!";
		 }

		 cout<<endl<<"Podaj wartosc parametru k=";
		 cin>>kParam;

		 if(kParam<=0)
		 {
		   cout<<endl<<"Niewlasciwa wartosc parametru. Przyjmuje domyslna wartosc k=3";
		   kParam=3;
		 }

		 cout<<endl<<"Podaj wartosc parametru m=";
		 cin>>mParam;
		 if(kParam<=0)
		 {
		   cout<<endl<<"Niewlasciwa wartosc parametru. Przyjmuje domyslna wartosc m=2";
		   mParam=2;
		 }
		 cin.sync();
	   break;
	   //*********************
	   case '1':
	   cout<<"Podaj pelna nazwe pliku tekstowego zawierajacego dane trenujace >>";
	   cin.getline(nazwa,STRING_LEN-1);
	   daneTrenujace.Czysc();
	   dane1Gotowe=daneTrenujace.WczytajZPliku(nazwa,TRYB_DANETRENUJACE);
		if(dane1Gotowe)
		 cout<<endl<<"Dane wczytano poprawnie";
		else
		  cout<<endl<<"Podczas wczytywania danych wystapil blad!";
	   break;
	   //*********************
	   case '2':
		   //testowanie
		   //sprawdzi zgodnoc liczby argumentow oraz wag
		   daneTrenujace.UstawParametry(wParam,kParam,mParam);
		   if(dane1Gotowe)
			{
			 cout<<endl<<"Start obliczen";
			 //Test LiveOneOut
			 Test(daneTrenujace,testErrors);
			 //wypisz bdy
			 testErrors.Pisz();
			 //wywietlic wyniki
			 daneTrenujace.Pisz(KLASARZE |KLASAROZ |SILAGLOSU |UFNOSC);

			  cout<<endl<<"Koniec obliczen";
			}
			else
			  cout<<endl<<"Nie wczytano danych!";

	   break;
		//********************
	   case '3':
		   cout<<"Podaj pelna nazwe pliku tekstowego z danymi do klasyfikacji >>";
		   cin.getline(nazwa,STRING_LEN-1);
		   daneDoRozpoznania.Czysc();
		   dane2Gotowe=daneDoRozpoznania.WczytajZPliku(nazwa,TRYB_DANEDOROZPOZNANIA);
		if(dane2Gotowe)
		 cout<<endl<<"Dane wczytano poprawnie";
		else
		  cout<<endl<<"Podczas wczytywania danych wystapil blad!";



	   break;
		//********************

	   case '4':
	   //klasyfikacja
		daneTrenujace.UstawParametry(wParam,kParam,mParam);
		//sprawdzi zgodnoc liczby argumetow w obu pliach oraz wag

		if(!dane1Gotowe || !dane2Gotowe)
		 cout<<endl<<"Nie wczytano danych!";
		else
		 {
			 cout<<endl<<"Start obliczen";
			 AlgorytmKNN(daneTrenujace, daneDoRozpoznania);
			 cout<<endl<<"Koniec obliczen";
			 wyniki2Gotowe=true;
		 }
	   break;
		//*********************
	   case '5':

		if(!dane1Gotowe)
		 cout<<endl<<"Nie wczytano danych!";
		else
		 {
		  daneTrenujace.Pisz(KLASARZE);
		  cout<<endl<<"Wczytano "<<daneTrenujace.DajLiczbeObiektow()<<" obiektow o "<<
		  daneTrenujace.DajLiczbaAtrybutow()<<" atrybutach";
		 }
	   break;
		 //***********************
	   case '6':
		if(!dane2Gotowe)
		 cout<<endl<<"Nie wczytano danych!";
		else
		 {
		  daneDoRozpoznania.Pisz();
		  cout<<endl<<"Wczytano "<<daneDoRozpoznania.DajLiczbeObiektow()<<" obiektow o "<<
		  daneDoRozpoznania.DajLiczbaAtrybutow()<<" atrybutach";
		 }
	   break;
		//*************************
	   case '7':
		   //wydruk wynikow
		if(!wyniki2Gotowe)
			cout<<endl<<"Brak wynikow do wyprowadzenia!";
		else
		 {
		   daneDoRozpoznania.Pisz(KLASAROZ| SILAGLOSU | UFNOSC);
		 }
	   break;
		 //*************************


	   case '9':
	   //zapis wynikw klasyfikacji
		if(!wyniki2Gotowe)
		 cout<<endl<<"Brak wynikow do wyprowadzenia!";
		else
		  {
			char nazwaPliku[STRING_LEN];
			cout<<endl<<"Podaj nazwe pliku wynikowego >>";
			cin.getline(nazwaPliku,STRING_LEN-1);
			if(daneDoRozpoznania.ZapiszDoPliku(nazwaPliku))
			 cout<<"Wynik zapisany do pliku "<<nazwaPliku<<endl;
		  }
	   break;
		  //************************

	   default:
			cout<<endl<<"Niepoprawny wybor!";
	  }


	}
	while(!stop);
 }

