//---------------------------------------------------------------------------
#pragma hdrstop
#include <iomanip>
#include "UMethods.h"


const double EPS=1e-12;
//---------------------------------------------------------------------------

void AlgorytmKNN(CTablicaObiektow & dTrenujace,CTablicaObiektow& dRozpoznawane)
{

  double *dystanse=new double [dTrenujace.DajLiczbeObiektow()];
  int *indeksy=new int [dTrenujace.DajLiczbeObiektow()];

  //wszystkie dane sterujce s w dTrenujace
  for (int i=0;i<dRozpoznawane.DajLiczbeObiektow();i++)
  {
	for(int ii=0;ii< dTrenujace.DajLiczbeObiektow();ii++)
		indeksy[ii]=ii;

	LiczDystanse(dystanse,dTrenujace,dRozpoznawane[i]);
   SortujDystanse(dystanse,indeksy,dTrenujace.DajLiczbeObiektow());
   Glosuj(dTrenujace,dRozpoznawane[i],dystanse,indeksy,dTrenujace.DajK());
  }

  delete [] dystanse;
  delete [] indeksy;
}
//---------------------------------------------------------------------------
void AlgorytmKNN(CTablicaObiektow & dTrenujace,SObiekt& Testowy)
{
  double *dystanse=new double [dTrenujace.DajLiczbeObiektow()];
  int *indeksy=new int [dTrenujace.DajLiczbeObiektow()];
  for(int ii=0;ii< dTrenujace.DajLiczbeObiektow();ii++) indeksy[ii]=ii;

  LiczDystanse(dystanse,dTrenujace,Testowy);
  SortujDystanse(dystanse,indeksy,dTrenujace.DajLiczbeObiektow());
  Glosuj(dTrenujace,Testowy,dystanse,indeksy,dTrenujace.DajK());


}
//---------------------------------------------------------------------------
void LiczDystanse(double *dystanse,CTablicaObiektow & daneTrenujace,
SObiekt & rozpoznawanyObiekt)
{

  SObiekt tmp;
  for(int i=0;i<daneTrenujace.DajLiczbeObiektow();i++)
   {
	tmp.Kopiuj(daneTrenujace[i]);
	dystanse[i]=0.0;
	 for(int j=0;j<daneTrenujace.DajLiczbaAtrybutow();j++)
	  {
	  if(daneTrenujace.DajW()==false)
	  dystanse[i]+=pow(fabs(tmp.atrybutyPtr[j]-rozpoznawanyObiekt.atrybutyPtr[j]),
	  daneTrenujace.DajM());
	  else
	   {
		double *wagi;
		daneTrenujace.DajWagi(&wagi);
		dystanse[i]+=pow(wagi[j]*fabs(tmp.atrybutyPtr[j]-rozpoznawanyObiekt.atrybutyPtr[j]),
		daneTrenujace.DajM());
		delete []wagi;
	   }
	  }
	  dystanse[i]=pow(dystanse[i],1.0/daneTrenujace.DajM());
   }

}
 //---------------------------------------------------------------------------
void SortujDystanse(double *dystanse,int *indeksy,int n)
{
  bool zmiany;

  do
  {
   zmiany=false;
	for(int i=1;i<n;i++)
	 if(dystanse[i-1]>dystanse[i])
	  {
		double tmp=dystanse[i-1];
		dystanse[i-1]=dystanse[i];
		dystanse[i]=tmp;
		int itmp=indeksy[i-1];
		indeksy[i-1]=indeksy[i];
		indeksy[i]=itmp;
		zmiany=true;
	  }

  }
  while(zmiany);
}

//---------------------------------------------------------------------------
void Glosuj(CTablicaObiektow& tren,
					 SObiekt& oRozp,double *dystanse,int *indeksy,int k)
{
 double glosy[2]={0.0};
 int liczbaGlosow[2]={0};
 for(int i=0;i<k;i++)
  {
   if(tren[indeksy[i]].klasaRzeczywista==0)
	 {
	  glosy[0]+=(1.0/(dystanse[i]*dystanse[i]+EPS));
	  liczbaGlosow[0]++;

	 }
	 else
	 {
	  glosy[1]+=(1.0/(dystanse[i]*dystanse[i]+EPS));
	  liczbaGlosow[1]++;
	 }
  }
   int idx=(glosy[0]>glosy[1])? 0:1;
   oRozp.klasaRozpoznana=idx;
   oRozp.silaGlosu=glosy[idx];
   oRozp.ufnosc=(double)liczbaGlosow[idx]/k;

}
//---------------------------------------------------------------------------
void Test(CTablicaObiektow & dTrenujace, SErrors &bledy)
{
	SObiekt Testowy,Wynik;
	CTablicaObiektow tmp;
	int FN=0,FP=0,TN=0,TP=0;

	double err2=0.0;
	for(int i=0;i<dTrenujace.DajLiczbeObiektow();i++)
	 {
	   Testowy=dTrenujace[i];
	   tmp.KopiujZWylaczeniem(dTrenujace,i); //stworzy funkcje
	   AlgorytmKNN(tmp,Testowy); //uwaga nowa wersja KNN

	   if(Testowy.klasaRozpoznana==0 && Testowy.klasaRzeczywista==0) TN++;
	   if(Testowy.klasaRozpoznana==1 && Testowy.klasaRzeczywista==1) TP++;
	   if(Testowy.klasaRozpoznana==0 && Testowy.klasaRzeczywista==1) FN++;
	   if(Testowy.klasaRozpoznana==1 && Testowy.klasaRzeczywista==0) FP++;
	   err2+= ((double)Testowy.klasaRozpoznana-Testowy.klasaRzeczywista)
			 *((double)Testowy.klasaRozpoznana-Testowy.klasaRzeczywista);

	   dTrenujace[i]=Testowy; //rozpoznanie
	 }

	 bledy.MSE=err2/(TP+TN+FP+FN);
	 bledy.TN=TN; bledy.TP=TP; bledy.FN=FN; bledy.FP=FP;
   	 LiczBledy(bledy);
}

//-------------------------------------------------------------------------
void LiczBledy(SErrors& E)
{

 if((E.TP+E.TN+E.FP+E.FN)==0)
  {
   E.overErr=0;
   E.skutecznosc=0;
   E.MatthewCorrCoeff=0;
  }
 else
 {
  E.overErr=(double)(E.FP+E.FN)/(E.TP+E.TN+E.FP+E.FN);
  E.skutecznosc=(double)(E.TP+E.TN)/(E.TP+E.TN+E.FP+E.FN);
  E.MatthewCorrCoeff=(double)(E.TP*E.TN-E.FP*E.FN)/sqrt((double)(E.TP+E.FN)*(E.TP+E.FP)*
	 (E.TN+E.FN)*(E.TN+E.FP));
  }
 if((E.TP+E.FN)==0)
   E.czulosc=0;
  else
   E.czulosc=(double)E.TP/(E.TP+E.FN);
 if((E.FP+E.TN)==0)
 {
   E.specyficznosc=0;
   E.falsePositiveRate=0;
 }
 else
  {
   E.specyficznosc=(double)E.TN/(E.FP+E.TN);
   E.falsePositiveRate=(double)E.FP/(E.FP+E.TN);
  }

 if((E.TP+E.FP)==0)
  {
   E.positivePreictiveValue=0;
   E.falseDiscoveryRate=0;
  }
 else
 {
  E.positivePreictiveValue=(double)E.TP/(E.TP+E.FP);
  E.falseDiscoveryRate=(double)E.FP/(E.FP+E.TP);
 }

 if((E.TN+E.FN)==0)
  E.negativePredictiveValue=0;
 else
  E.negativePredictiveValue=(double)E.TN/(E.TN+E.FN);

 if(E.czulosc+E.positivePreictiveValue==0)
   E.F1Score=0;
 else
  E.F1Score=2.0*(double)E.czulosc *E.positivePreictiveValue/
			  (E.czulosc +E.positivePreictiveValue);

}

//-----------------------------------------------------------------------------
void SErrors::Pisz(void)
{
  cout<<endl;
  cout<<"***************OCENA KLASYFIKATORA****************"<<endl;
  cout<<"Macierz pomylek"<<endl;
  cout<<setw(20)<<"PRED"<<endl;
  cout<<setw(5)<<"K RZ"<<setw(10)<<"TN="<<this->TN<<setw(10)<<"FP="<<this->FP<<endl;
  cout<<setw(5)<<"    "<<setw(10)<<"FN="<<this->FN<<setw(10)<<"TP="<<this->TP<<endl;
  cout<<endl;
  cout<<"Blad calkowity= "<<this->overErr<<endl;
  cout<<"Trafnosc= "<<this->skutecznosc<<endl;
  cout<<"Czulosc= "<<this->czulosc<<endl;
  cout<<"Specyficznosc= "<<this->specyficznosc<<endl;
  cout<<"FPR (False positive rate)= "<<this->falsePositiveRate<<endl;
  cout<<"PPV (Positive predictive value)= "<<this->positivePreictiveValue<<endl;
  cout<<"NPV (Negative predictive value)= "<<this->negativePredictiveValue<<endl;
  cout<<"FDR (False discovery rate)= "<<this->falseDiscoveryRate<<endl;
  cout<<"MCC (Matthew\'s correlation coefficient)= "<<this->MatthewCorrCoeff<<endl;
  cout<<"F1S (F1 score)= "<<this->F1Score<<endl;
  cout<<"MSE="<<this->MSE<<endl;
  cout<<"***********************************************"<<endl;


}
//---------------------------------------------------------------------------
#pragma package(smart_init)
